package testcase.ejbs;

import testcase.interfaces.*;
import testcase.entities.*;
import javax.persistence.*;
import javax.ejb.*;
import java.util.*;

@Stateless()
@Local()
public class TestImpl implements TestManager {
    
    @PersistenceContext(unitName="primary")
    private EntityManager firstEM;
    
    @PersistenceContext(unitName="secondary")
    private EntityManager secondEM;

    public List<First> getFirsts() {
        Query query = firstEM.createQuery(
                "SELECT f FROM First f"
            );
        return (List<First>)query.getResultList();
    }
    public List<Second> getSeconds() {
        Query query = secondEM.createQuery(
                "SELECT s FROM Second s"
            );
        return (List<Second>)query.getResultList();
    }

    public First findFirst(Integer id) {
        return firstEM.find(First.class, id);
    }

    public Second findSecond(Integer id) {
        return secondEM.find(Second.class, id);
    }

    public Integer createFirst(String data) {
        First first = new First();
        first.setData(data);
        firstEM.persist(first);
        return first.getId();
    }

    public Integer createSecond(String name, String data) {
        Second second = new Second();
        second.setData(data);
        second.setName(name);
        secondEM.persist(second);
        return second.getId();
    }
    
    public void makeSeconds() {
        List<First> firsts = getFirsts();
        List<Second> seconds = getSeconds();
        int i = 0;
        for (First first: firsts) {
            Second second = new Second();
            second.setData(first.getData());
            i++;
            second.setName("made by makeSeconds #"+i);
            secondEM.persist(second);
        }
    }
}